SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'testing' stamp: 'Nicolas 5/9/2012 21:39'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	|acustomerBook  ablock|
	
	acustomerBook := CustomerBook  new.
	
	

      self assert:( acustomerBook checkIfAddingOrRemoving:  [acustomerBook addCustomerNamed: 'John Lennon'.] DoesntTakeMoreThanAGivenTime: 50).
! !

!IdiomTest methodsFor: 'testing' stamp: 'Nicolas 5/9/2012 21:43'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	|acustomerBook  ablock|
	
	acustomerBook := CustomerBook  new.
	
	acustomerBook addCustomerNamed: 'John Lennon'.

      self assert:( acustomerBook checkIfAddingOrRemoving:  [acustomerBook removeCustomerNamed: 'John Lennon'.] DoesntTakeMoreThanAGivenTime: 100).! !

!IdiomTest methodsFor: 'testing' stamp: 'Nicolas 5/9/2012 21:44'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.

	[ customerBook addCustomerNamed: ''.
	self fail ]
		on: Error 
		do: [ :anError | 
			self assert: anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.
			self assert: customerBook isEmpty ]! !

!IdiomTest methodsFor: 'testing' stamp: 'Nicolas 5/9/2012 21:43'!
test04CanNotAddRepeatedCustomer 
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	[ customerBook removeCustomerNamed: 'Paul McCartney'.
	self fail ]
		on: NotFound 
		do: [ :anError | 
			self assert: customerBook numberOfCustomers = 1.
			self assert: (customerBook includesCustomerNamed: johnLennon) ]
! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'as yet unclassified' stamp: 'Nicolas 5/9/2012 20:43'!
checkIfAddingOrRemoving: addOrRemove DoesntTakeMoreThanAGivenTime: aGivenTime

	"comment stating purpose of message"

	| millisecondsBeforeRunning millisecondsAfterRunning |

	
	millisecondsBeforeRunning := Time millisecondClockValue.
	addOrRemove value.
	millisecondsAfterRunning := Time millisecondClockValue.
	
      ^ (millisecondsAfterRunning-millisecondsBeforeRunning) < aGivenTime! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
